var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
define(["require", "exports", "./jq_qs", "./web-fcs-api-base", "./fcs-validate"], function (require, exports, jq_qs_1, BaseApi, fcs_validate_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.FC_Solve_Bookmarking = exports.set_up__capitalize_cards = exports.populate_input_with_numbered_deal = exports.escapeHtml = void 0;
    BaseApi = __importStar(BaseApi);
    const entityMap = {
        '"': "&quot;",
        "&": "&amp;",
        "'": "&#39;",
        "/": "&#x2F;",
        "<": "&lt;",
        ">": "&gt;",
    };
    function escapeHtml(str) {
        return String(str).replace(/[&<>"'\/]/g, (s) => entityMap[s]);
    }
    exports.escapeHtml = escapeHtml;
    // Thanks to Stefan Petrea ( http://garage-coding.com/ ) for inspiring this
    // feature.
    function populate_input_with_numbered_deal(module_wrapper, w) {
        const input_s = $("#deal_number").val();
        if (!input_s.match(/^[1-9][0-9]*$/)) {
            alert("Wrong input - please enter a positive integer.");
            return;
        }
        const MAX = 8589934591;
        const previous_deal_idx = parseInt(input_s, 10);
        if (input_s.length > 10 || previous_deal_idx > MAX) {
            alert("Wrong input - deal number must be in the range 1 to " + MAX);
            return;
        }
        const stdin = $("#stdin");
        stdin.val("# MS Freecell Deal #" +
            previous_deal_idx +
            "\n#\n" +
            BaseApi.deal_ms_fc_board(module_wrapper, previous_deal_idx));
        // For tests:
        stdin.trigger("change");
        return;
    }
    exports.populate_input_with_numbered_deal = populate_input_with_numbered_deal;
    function set_up__capitalize_cards() {
        $("#capitalize_cards").click(() => {
            const ctl = $("#stdin");
            ctl.val(fcs_validate_1.capitalize_cards(ctl.val()));
            return;
        });
        return;
    }
    exports.set_up__capitalize_cards = set_up__capitalize_cards;
    class FC_Solve_Bookmarking {
        constructor(args) {
            const that = this;
            that.bookmark_controls = args.bookmark_controls;
            that.show = args.show;
            return;
        }
        on_bookmarking() {
            const that = this;
            function get_v(myid) {
                const ctl = $("#" + myid);
                return that._is_toggley(ctl)
                    ? ctl.is(":checked")
                        ? "1"
                        : "0"
                    : ctl.val();
            }
            const control_values = {};
            that._each_control((myid) => {
                control_values[myid] = get_v(myid);
            });
            const bookmark_string = that._get_base_url() + "?" + jq_qs_1.jq_querystring(control_values);
            $("#fcs_bm_results_input").val(bookmark_string);
            const a_elem = $("#fcs_bm_results_a");
            // Too long to be effective.
            // a_elem.text(bookmark_string);
            a_elem.attr("href", bookmark_string);
            $("#fcs_bookmark_wrapper").removeClass("disabled");
            return;
        }
        restore_bookmark() {
            const that = this;
            const qs = that._get_loc().search;
            if (!qs.length) {
                return;
            }
            // Remove trailing 1.
            const params = jq_qs_1.jq_querystring(qs.substr(1));
            that._each_control((myid) => {
                const ctl = $("#" + myid);
                const val = params[myid];
                if (that._is_toggley(ctl)) {
                    ctl.prop("checked", String(val) === "1" ? true : false);
                }
                else {
                    ctl.val(val);
                }
            });
            for (const rec of that.show) {
                const id = rec.id;
                const deps = rec.deps;
                const should_toggle = deps.some((d) => {
                    return $("#" + d).val().length > 0;
                });
                if (should_toggle) {
                    if ($("#" + id).hasClass("disabled")) {
                        rec.callback();
                    }
                }
            }
            return;
        }
        _is_toggley(ctl) {
            return ctl.is(":checkbox") || ctl.is(":radio");
        }
        _get_loc() {
            return window.location;
        }
        _get_base_url() {
            const that = this;
            const loc = that._get_loc();
            return loc.protocol + "//" + loc.host + loc.pathname;
        }
        _each_control(cb) {
            const that = this;
            that.bookmark_controls.forEach(cb);
            return;
        }
    }
    exports.FC_Solve_Bookmarking = FC_Solve_Bookmarking;
});
