var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
define(["require", "exports", "./s2ints_js", "./fcs-base-ui", "./libfcs-wrap", "./find-fc-deal"], function (require, exports, s2i, base_ui, libfcs_wrap_1, w) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.set_up = exports.set_up_handlers = exports.find_deal_ui = exports.init_module = void 0;
    s2i = __importStar(s2i);
    base_ui = __importStar(base_ui);
    libfcs_wrap_1 = __importDefault(libfcs_wrap_1);
    w = __importStar(w);
    let _module_wrapper;
    function init_module(cb) {
        const _my_module = libfcs_wrap_1.default({
            onRuntimeInitialized: () => {
                _my_module.then((result) => {
                    const module_wrapper = w.FC_Solve_init_wrappers_with_module(result);
                    _module_wrapper = module_wrapper;
                    cb(module_wrapper);
                    return 0;
                });
            },
        });
    }
    exports.init_module = init_module;
    function _create_bmark_obj() {
        return new base_ui.FC_Solve_Bookmarking({
            bookmark_controls: ["stdin", "deal_number"],
            show: [],
        });
    }
    function on_bookmarking() {
        return _create_bmark_obj().on_bookmarking();
    }
    function restore_bookmark() {
        return _create_bmark_obj().restore_bookmark();
    }
    // Taken from https://stackoverflow.com/questions/2901102/
    // thanks.
    function numberWithCommas(x) {
        return x.replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }
    function getRounderNumber(str) {
        return str.replace(/(000)1$/, "$10");
    }
    function find_deal_ui() {
        const deal_str = $("#stdin").val()
            .replace(/#[^\r\n]*\r?\n?/g, "")
            .replace(/\r+\n/, "\n")
            .replace(/([^\n])$/, "$1\n");
        const ints = s2i.find_index__board_string_to_ints(deal_str);
        const ints_s = ints
            .map((i) => {
            const ret = i.toString();
            return " ".repeat(10 - ret.length) + ret;
        })
            .join("");
        const df = new w.Freecell_Deal_Finder({ module_wrapper: _module_wrapper });
        df.fill(ints_s);
        const ctl = $("#fc_solve_status");
        df.run(1, "8589934591", (args) => {
            ctl.html(base_ui.escapeHtml("Reached No. " +
                numberWithCommas(getRounderNumber(args.start.toString()))));
            return;
        });
        function resume() {
            const ret_Deal = df.cont();
            if (ret_Deal.found) {
                ctl.html('Found: <input id="found_result" ' +
                    'name="found_result" value="' +
                    ret_Deal.result.toString() +
                    '" readonly="readonly" />');
            }
            else if (ret_Deal.cont) {
                setTimeout(() => {
                    resume();
                }, 1);
            }
            else {
                ctl.html("No such deal");
            }
        }
        resume();
        return;
    }
    exports.find_deal_ui = find_deal_ui;
    function set_up_handlers(module_wrapper) {
        $("#populate_input").click(() => {
            return base_ui.populate_input_with_numbered_deal(module_wrapper, w);
        });
        $("#run_do_solve").click(find_deal_ui);
        base_ui.set_up__capitalize_cards();
        return;
    }
    exports.set_up_handlers = set_up_handlers;
    function set_up(module_wrapper) {
        restore_bookmark();
        set_up_handlers(module_wrapper);
        $("#fc_solve_bookmark_button").click(on_bookmarking);
        return;
    }
    exports.set_up = set_up;
});
