"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

// Generated by CoffeeScript 2.5.1
(function () {
  /*
   Copyright (c) 2013-2015 Nick Kugaevsky
   Licensed under the MIT License
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
  OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
  DEALINGS IN THE SOFTWARE.
   Phoenix is a simple jQuery plugin to make your form
  input safe (I mean save) in your browser's local storage.
   @version 1.2.3
  @url github.com/kugaevsky/jquery-phoenix
  ---------------------
   FEATURES:
  - HTML5 localStorage persistance
  - Simple event API
  – Configurable usage
   */
  (function ($, window) {
    "use strict";

    var Phoenix, defaults, pluginName, saveTimers, supportsHtml5Storage;
    pluginName = "phoenix";
    defaults = {
      namespace: "phoenixStorage",
      webStorage: "localStorage",
      maxItems: 100,
      saveInterval: 1000,
      clearOnSubmit: false,
      saveOnChange: false,
      keyAttributes: ["tagName", "id", "name"]
    };
    saveTimers = [];

    Phoenix = /*#__PURE__*/function () {
      function Phoenix(element, option) {
        _classCallCheck(this, Phoenix);

        var attr, storageArray;
        this.element = element;
        this._defaults = defaults;
        this._name = pluginName;
        this.$element = $(this.element);
        this.options = $.extend({}, defaults, _typeof(option) === "object" ? option : void 0);

        if (typeof option === "string") {
          this.action = option;
        }

        this.uri = window.location.host + window.location.pathname;
        storageArray = [this.options.namespace, this.uri].concat(function () {
          var j, len, ref, results;
          ref = this.options.keyAttributes;
          results = [];

          for (j = 0, len = ref.length; j < len; j++) {
            attr = ref[j];
            results.push(this.element[attr]);
          }

          return results;
        }.call(this));
        this.storageKey = storageArray.join(".");
        this.storageIndexKey = [this.options.namespace, "index", window.location.host].join(".");
        this.webStorage = window[this.options.webStorage];
        this.init();
      }

      _createClass(Phoenix, [{
        key: "indexedItems",
        value: function indexedItems() {
          return JSON.parse(this.webStorage[this.storageIndexKey]);
        }
      }, {
        key: "remove",
        value: function remove() {
          var e, indexedItems;
          this.stop();
          this.webStorage.removeItem(this.storageKey);
          e = $.Event("phnx.removed");
          this.$element.trigger(e);
          indexedItems = this.indexedItems();
          indexedItems.slice($.inArray(this.storageKey, indexedItems), 1);
          this.webStorage[this.storageIndexKey] = JSON.stringify(indexedItems);
        }
      }, {
        key: "updateIndex",
        value: function updateIndex() {
          var indexedItems;
          indexedItems = this.indexedItems();

          if ($.inArray(this.storageKey, indexedItems) === -1) {
            indexedItems.push(this.storageKey);

            if (indexedItems.length > this.options.maxItems) {
              this.webStorage.removeItem(indexedItems[0]);
              indexedItems.shift();
            }

            this.webStorage[this.storageIndexKey] = JSON.stringify(indexedItems);
          }
        }
      }, {
        key: "load",
        value: function load() {
          var _this = this;

          var e, savedValue;
          savedValue = this.webStorage[this.storageKey];

          if (savedValue != null) {
            if (this.$element.is(":checkbox, :radio")) {
              this.element.checked = JSON.parse(savedValue);
            } else if (this.element.tagName === "SELECT") {
              this.$element.find("option").prop("selected", false);
              $.each(JSON.parse(savedValue), function (i, value) {
                return _this.$element.find('option').filter(function () {
                  return value === $(this).val();
                }).prop("selected", true);
              });
            } else {
              this.element.value = savedValue;
            }

            e = $.Event("phnx.loaded");
            return this.$element.trigger(e);
          }
        }
      }, {
        key: "save",
        value: function save() {
          var e, selectedValues;
          this.webStorage[this.storageKey] = this.$element.is(":checkbox, :radio") ? this.element.checked : this.element.tagName === "SELECT" ? (selectedValues = $.map(this.$element.find("option:selected"), function (el) {
            return el.value;
          }), JSON.stringify(selectedValues)) : this.element.value;
          e = $.Event("phnx.saved");
          this.$element.trigger(e);
          return this.updateIndex();
        }
      }, {
        key: "start",
        value: function start() {
          var _this2 = this;

          var e, saveTimer;
          saveTimer = this.options.saveInterval >= 0 ? setInterval(function () {
            return _this2.save();
          }, this.options.saveInterval) : setTimeout(function () {
            return _this2.save();
          });
          saveTimers.push(saveTimer);
          e = $.Event("phnx.started");
          return this.$element.trigger(e);
        }
      }, {
        key: "stop",
        value: function stop() {
          var e;
          saveTimers.forEach(function (t) {
            return clearInterval(t);
          });
          e = $.Event("phnx.stopped");
          return this.$element.trigger(e);
        }
      }, {
        key: "init",
        value: function init() {
          var _this3 = this;

          if (this.webStorage[this.storageIndexKey] === void 0) {
            this.webStorage[this.storageIndexKey] = "[]";
          }

          switch (this.action) {
            case "remove":
              return this.remove();

            case "start":
              return this.start();

            case "stop":
              return this.stop();

            case "load":
              return this.load();

            case "save":
              return this.save();

            default:
              this.load();
              this.start();

              if (this.options.clearOnSubmit) {
                $(this.options.clearOnSubmit).submit(function () {
                  return _this3.remove();
                });
              }

              if (this.options.saveOnChange) {
                return $(this.element).change(function () {
                  return _this3.save();
                });
              }

          }
        }
      }]);

      return Phoenix;
    }();

    supportsHtml5Storage = function supportsHtml5Storage(webStorage) {
      try {
        return webStorage in window && window[webStorage] !== null;
      } catch (error) {
        return false;
      }
    };

    $.fn[pluginName] = function (option) {
      var pluginID;
      pluginID = "plugin_".concat(pluginName);
      return this.each(function () {
        if (!($.data(this, pluginID) && !supportsHtml5Storage(option.webStorage || defaults.webStorage))) {
          return $.data(this, pluginID, new Phoenix(this, option));
        }
      });
    };
  })(jQuery, window);
}).call(void 0);
